/*
 * Evolve Function
 */
#include "hexgridplus.hpp"
using namespace hexagonplus;
#include "evolve.hpp"

extern hexagondev dev; //device
extern double time_step; //time step in calculation
extern double* var_; //var next time
extern double* incvar; //var increase
extern double* incvar_; //var_ increase
extern int varnum; //number of variables
int it; //iterator

void Evolve(double* var, double t,
            void (*Func)(double* return_increase, double t, double* input_var))
{
    Func(incvar, t, var);
    for (it=0;it<varnum*dev.GetNodeNumber();++it)
    {
        var_[it]=var[it]+incvar[it]*time_step;
    }
    Func(incvar_, t+time_step, var_);
    for (it=0;it<varnum*dev.GetNodeNumber();++it)
    {
        var[it]+=(incvar[it]+incvar_[it])/2*time_step;
    }
}

