/*
 * Hexagonal Grid for Dynamic System Simulation
 * Author: niasw
 */

#ifndef _HEXGRID_PLUS_
#define _HEXGRID_PLUS_

#include "hexgrid.hpp"

namespace hexagonplus
{
    using namespace hexagon;
    double IntegrateAround(const hexagondev& device, const double* valueset,
                           int radius, int order1,
                           double (*func)(const veci& vec1, const veci& vec2,
                                          double value1, double value2));
    /*radius is in step-counting units, not in distance units*/
    /*I(x1)=integrate(func(x1,x2,v1,v2)d(x2))*/
}

#endif

